<template>
  <div class="application-center-test">
    <div class="header">
      {{$t('applicationCenter.title')}}
      <div class="back" @click="$router.go(-1)">{{$t('applicationCenter.back')}}</div>
    </div>
    <div class="clear" @click="clear()">{{$t('applicationCenter.clear')}}</div>
    <div class="module">
      <h3>walletPluginContractInvoke{{$t('applicationCenter.ContractInvocation')}}</h3>
      <div class="input-container">
        <input type="text" placeholder="regId" v-model="regId">
      </div>
      <div class="input-container">
        <input type="text" placeholder="contractFild" v-model="contractFild">
      </div>
      <div class="input-container price">
        <input type="text" placeholder="inputAmount" v-model="inputAmount">
      </div>
      <div class="input-container price-change" v-if="inputAmount">
        <div class="change">{{inputAmount*Math.pow(10, 8)}}</div>
      </div>
      <div class="input-container">
        <input type="text" placeholder="remark" v-model="remark">
      </div>
      <button @click="contractInvokeTest()">{{$t('applicationCenter.test')}}</button>
      <div class="res-container">
        <p class="title">{{$t('applicationCenter.result')}}:</p>
        <p class="result">{{contractInvokeRes}}</p>
      </div>
    </div>
    <div class="module">
      <h3>walletPluginContractIssue{{$t('applicationCenter.ContractPublish')}}</h3>
      <div class="input-container">
        <input type="text" placeholder="contractContent" v-model="contractContent">
      </div>
      <div class="input-container">
        <input type="text" placeholder="contractDesc" v-model="contractDesc">
      </div>
      <button @click="walletPluginContractIssueTest()">{{$t('applicationCenter.test')}}</button>
      <div class="res-container">
        <p class="title">{{$t('applicationCenter.result')}}:</p>
        <p class="result">{{contractIssueRes}}</p>
      </div>
    </div>
    <div class="module">
      <h3>walletPluginTransfer{{$t('wallet.transfer')}}</h3>
      <div class="input-container price">
        <input type="text" placeholder="amount" v-model="amount">
      </div>
      <div class="input-container price-change" v-if="amount">
        <div class="change">{{amount*Math.pow(10, 8)}}</div>
      </div>
      <div class="input-container">
        <input type="text" placeholder="collectionAddress" v-model="collectionAddress">
      </div>
      <div class="input-container">
        <input type="text" placeholder="remark" v-model="remark">
      </div>
      <button @click="TransferTest()">{{$t('applicationCenter.test')}}</button>
      <div class="res-container">
        <p class="title">{{$t('applicationCenter.result')}}:</p>
        <p class="result">{{transferRes}}</p>
      </div>
    </div>
    <div class="module" v-if="true">
      <h3>walletPluginNodeVote{{$t('applicationCenter.note')}}</h3>
      <template v-for="(item, index) in nodeList">
        <div :key="'index'+index" v-if="nodeList.length !== 1" @click="delNode(index)">{{index+1}}.删除</div>
        <div class="input-container" :key="'address'+index">
          <input type="text" placeholder="votedAddress" v-model="item.votedAddress">
        </div>
        <div class="input-container price" :key="'count'+index">
          <input type="text" placeholder="voteCount" v-model="item.voteCount">
        </div>
      <div class="input-container price-change" :key="'change' + index" v-if="item && item.voteCount">
        <div class="change">{{item.voteCount*Math.pow(10, 8)}}</div>
      </div>
      </template>
      <button @click="addNode()">{{$t('applicationCenter.add')}}</button>
      <button @click="nodeVoteTest()">{{$t('applicationCenter.test')}}</button>
      <div class="res-container">
        <p class="title">{{$t('applicationCenter.result')}}:</p>
        <p class="result">{{NodeVoteRes}}</p>
      </div>
    </div>
    <div class="module">
      <h3>getAddressInfo{{$t('applicationCenter.getAccount')}}</h3>
      <!-- <div class="input-container">
        <input type="text" placeholder="address" v-model="address">
      </div>
      <div class="input-container">
        <input type="text" placeholder="netWork" v-model="netWork">
      </div>
      <div class="input-container">
        <input type="text" placeholder="supplier" v-model="supplier">
      </div> -->
      <button @click="getAddressInfo()">{{$t('applicationCenter.test')}}</button>
      <div class="res-container">
        <p class="title">{{$t('applicationCenter.result')}}:</p>
        <p class="result">{{getAddressInfoRes}}</p>
      </div>
    </div>
  </div>
</template>
<script>
export default {
  data() {
    return {
      regId: "2286881-1",
      contractFild: "f01234",
      inputAmount: "0.01",
      remark: this.$t('add.remark'),
      contractInvokeRes: null, // 合约调用返回信息
      amount: "0.01",
      collectionAddress: "0-2",
      contractContent: "mylib = require \"mylib\"",
      contractDesc: "111",
      nodeList: [{}],
      address: "Wi2H3XAhMtdLPkjQVSkYXhF3GRNTwAhtqA",
      netWork: "mainnet",
      supplier: "WaykiTimes",
      contractIssueRes: null, // 合约发布返回信息
      transferRes: null, // wicc转账返回信息
      NodeVoteRes: null, // 节点投票返回信息
      getAddressInfoRes: null, // 根据地址返回账户信息
    };
  },
  created() {},
  methods: {
    clear() {
     this.collectionAddress = "";
      this.contractIssueRes ="";
      this.transferRes = "";
      this.NodeVoteRes = "";
      this.getAddressInfoRes = "";
    },
    // 合约调用
    contractInvokeTest() {
      const _this = this;
      waykiBridge.walletPlugin(
        "walletPluginContractInvoke",
        {
          regId: this.regId, //合约id
          contractField: this.contractFild, //合约字段
          inputAmount: String(Number(this.inputAmount) * Math.pow(10, 8)), //输入金额（没有传0）
          remark: this.remark //备注，如：猜数字
        },
        function(res) {
          _this.contractInvokeRes = res;
        },
        function(err) {
          _this.contractInvokeRes = err;
        }
      );
    },
    // 合约发布
    walletPluginContractIssueTest() {
      const _this = this;
      waykiBridge.walletPlugin(
        "walletPluginContractIssue",
        {
          contractContent: this.contractContent, //合约内容
          contractDesc: this.contractDesc //合约描述
        },
        function(res) {
          console.log('suc合约发布')
          console.log(Object.prototype.toString.call(res))
          _this.contractIssueRes = res;
        },
        function(err) {
          console.log('err合约发布')
          console.log(Object.prototype.toString.call(err))
          _this.contractIssueRes = err;
        }
      );
    },
    // 转账
    TransferTest() {
      const _this = this;
      waykiBridge.walletPlugin(
        "walletPluginTransfer",
        {
          amount: String(Number(this.amount) * Math.pow(10, 8)), //转账金额
          collectionAddress: this.collectionAddress, //转账地址
          remark: this.remark
        },
        function(res) {
          console.log('suc转账')
          console.log(res)
          _this.transferRes = res;
        },
        function(err) {
          console.log('err转账')
          console.log(Object.prototype.toString.call(err))
          _this.transferRes = err;
        }
      );
    },
    // 节点投票
    nodeVoteTest() {
      const _this = this;
      // this.nodeList = this.nodeList.map(item => ({...item, voteCount: String(Number(item.voteCount) * Math.pow(10, 8))}))
      let nodeList = JSON.parse(JSON.stringify(this.nodeList))
      nodeList = nodeList.map(item => ({...item, voteCount: String(Number(item.voteCount) * Math.pow(10, 8))}))
      waykiBridge.walletPlugin(
        "walletPluginNodeVote",
        {
          nodeList: nodeList
        },
        function(res) {
          _this.NodeVoteRes = res;
        },
        function(err) {
          _this.NodeVoteRes = err;
        }
      );
    },
    // 根据地址获取账户信息
    getAddressInfo() {
      const _this = this;
      waykiBridge.walletPlugin(
        "getAddressInfo",
        {
          // address: this.address, //转账地址
          // netWork: this.netWork,
          // supplier: this.supplier
        },
        function(res) {
          console.log('suc')
          _this.getAddressInfoRes = res;
        },
        function(err) {
          console.log('err')
          _this.getAddressInfoRes = err;
        }
      );
    },
    // 删除节点
    delNode(index) {
      this.nodeList.splice(index, 1)
    },
    // 添加节点
    addNode() {
      if (this.nodeList.length >= 12) return;
      this.nodeList.push({});
    }
  }
};
</script>
<style lang="less" scope>
.application-center-test {
  .header {
    position: fixed;
    left: 0;
    top: 0;
    text-align: center;
    width: 100%;
    height: 0.42rem;
    line-height: 0.42rem;
    border-bottom: 0.01rem solid #ededed;
    font-size: 0.18rem;
    font-weight: bold;
    background-color: #ffffff;
    z-index: 999;
    .back{
      position: absolute;
      left: 0.1rem;
      top: 0;
    }
  }
  * {
    box-sizing: border-box;
  }
  .clear{
    position: fixed;
    right: 0.1rem;
    bottom: 0.1rem;
    background-color: #2e83fc;
    color: #ffffff;
    width: 1rem;
    height: 0.3rem;
    line-height: 0.3rem;
    text-align: center;
    border-radius: 0.08rem;
    z-index: 999;
  }
  text-align: left;
  .module {
    padding: 0 0.1rem;
    margin-top: 0.3rem;
    h3 {
      font-size: 0.26rem;
      color: #2f2f2f;
    }
    .input-container {
      margin-top: 0.1rem;
      input {
        padding: 0 0.1rem;
        width: 100%;
        border: 1px solid #2e83fc;
        height: 0.4rem;
        line-height: 0.4rem;
      }
    }
    p{
      word-wrap:break-word;
    }
    .price-change{
      height: 0.4rem;
      line-height: 0.4rem;
      position: relative;
      &::after{
        content: "sawi";
        position: absolute;
        right: 0.1rem;
        top:0;
        height: 0.4rem;
        line-height: 0.4rem;
        z-index: 999;
      }
    }
    .price{
      position: relative;
      &::after{
        content: "WICC";
        position: absolute;
        right: 0.1rem;
        height: 0.4rem;
        line-height: 0.4rem;
        z-index: 999;
      }
    }
  }
  button {
    margin-top: 0.1rem;
    width: 100%;
    height: 0.4rem;
    background-color: #2e83fc;
    color: #ffffff;
  }
  .res-container {
    margin-top: 0.1rem;
    .title {
      font-size: 0.2rem;
    }
    .result {
      font-size: 0.14rem;
      margin-top: 0.1rem;
    }
  }
}
</style>